// Poor Data Injector
// 2015-2016 Seyma Nur Soydemir seyma@student.dei.uc.pt

package filter;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Timestamp;
import java.util.ArrayList;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;

/**
 * Servlet Filter
 */
@WebFilter("/MyService/*")
public class MyFilter implements Filter {

 private static String static_useractions = "D:\\thesis\\UserActions.txt";
 private static ArrayList < String > requestList = new ArrayList < String > ();
 private static PrintWriter writer = null;

 /**
  * Default constructor.
  */
 public MyFilter() {}

 // Helper function to write a string to file
 public void writeToFile(String content) {
  try {
   if (writer == null) {
    writer = new PrintWriter(new FileOutputStream(static_useractions, true));
   }
  } catch (FileNotFoundException e) {

   e.printStackTrace();
  }

  writer.println(content);
  writer.flush();
 }

 // Helper function to write an exception to file
 public void writeExceptionToFile(Exception ea) {
  try {
   if (writer == null) {
    writer = new PrintWriter(new FileOutputStream(static_useractions, true));
   }
  } catch (FileNotFoundException e) {
   e.printStackTrace();
  }
  ea.printStackTrace(writer);
  writer.flush();
 }

 /**
  * @see Filter#destroy()
  */
 @Override
 public void destroy() {
  // TODO Auto-generated method stub
 }


 @Override
 public synchronized void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
  java.util.Date dateStart = new java.util.Date();
  Timestamp timeStart = new Timestamp(dateStart.getTime());
  writeToFile("Request Start Time: " + timeStart);
  HttpServletRequest req = (HttpServletRequest) request;
  writeToFile("URL: " + req.getRequestURL());
  intercept.MyAspect.injection = true;

  // Catch any exception from application and log to file
  try {
   chain.doFilter(request, response);
  } catch (Exception e) {
   writeToFile("Application Exception!");
   writeExceptionToFile(e);
   writeToFile("\n");
  }


  java.util.Date dateEnd = new java.util.Date();
  Timestamp timeEnd = new Timestamp(dateEnd.getTime());
  writeToFile("END TIME:" + timeEnd);
 }


 /**
  * @see Filter#init(FilterConfig)
  */
 @Override
 public void init(FilterConfig fConfig) throws ServletException {
  System.out.println("Initializing filter...");



 }

}