// Poor Data Injector
// 2015-2016 Seyma Nur Soydemir seyma@student.dei.uc.pt

package mutation;

import java.util.Arrays;
import java.util.Random;

public class Operators_Binary {

 // Variable that holds the name of the last executed mutation
 public static String nameOfLastExecutedFunction = null;

 public interface functionOneParameter {
  byte[] run(byte[] input);
 }
 public interface functionTwoParameters {
  byte[] run(byte[] input, String position);
 }
 public interface functionTwoParameters2 {
  byte[] run(byte[] input, int X);
 }

 // Method 1:	Replace by null value	  -  	  -
 public static final functionOneParameter m1_replaceByNull = new functionOneParameter() {

  @Override
  public byte[] run(byte[] input) {
   nameOfLastExecutedFunction = "m1_replaceByNull";
   return null;
  }
 };

 // Method 2:	Replace by empty
 public static final functionOneParameter m2_replaceByEmpty = new functionOneParameter() {

  @Override
  public byte[] run(byte[] input) {
   nameOfLastExecutedFunction = "m2_replaceByEmpty";

   byte[] output = {};
   return output;
  }
 };

 // Helper function that adds a new element to integer list
 static int[] addElement(int[] a, int e) {

  a = Arrays.copyOf(a, a.length + 1);
  a[a.length - 1] = e;
  return a;
 }


 // Method 3:	Add byte
 // Parameters:
 // 	Position: Prefix - Middle  - Suffix
 // 	Value:    Random from 0 to 255
 public static final functionTwoParameters m3_addByte = new functionTwoParameters() {

  @Override
  public byte[] run(byte[] input, String position) {
   nameOfLastExecutedFunction = "m3_addByte";
   byte[] output = Arrays.copyOf(input, input.length + 1);
   Random random = new Random();
   byte randomByte = (byte) random.nextInt(256);
   byte temp = 0;
   int randomPosition = 0;

   if (position.equalsIgnoreCase("prefix")) {
    for (int i = 0; i < input.length; i++) {
     output[i + 1] = output[i];
    }
    output[0] = randomByte;
    return output;

   }
   if (position.equalsIgnoreCase("middle")) {
    randomPosition = random.nextInt(input.length);

    for (int i = randomPosition; i < input.length; i++) {
     output[i + 1] = output[i];
    }
    output[randomPosition] = randomByte;
    return output;

   }
   if (position.equalsIgnoreCase("suffix")) {
    output[input.length] = randomByte;
    return output;
   }
   return input;
  }
 };

 // Method 4: Remove bytes
 // Parameters:
 // 	Position: Prefix - Middle - Suffix
 // 	Quantity: From 1 to size of Binary - Position
 public static final functionTwoParameters m4_removeByte = new functionTwoParameters() {

  @Override
  public byte[] run(byte[] input, String position) {
   nameOfLastExecutedFunction = "m4_removeByte";
   byte[] output = new byte[input.length - 1];
   Random random = new Random();
   int randomPosition = random.nextInt(input.length);
   byte temp = 0;

   if (position.equalsIgnoreCase("prefix")) {
    int output_counter = 0;
    for (int input_counter = 1; input_counter < input.length; input_counter++) {
     output[output_counter] = input[input_counter];
     output_counter++;
    }
    return output;

   }
   if (position.equalsIgnoreCase("middle")) {
    int output_counter = 0;
    for (int input_counter = 0; input_counter < input.length; input_counter++) {
     if (input_counter != randomPosition) {
      output[output_counter] = input[input_counter];
      output_counter++;
     }
    }
    return output;
   }

   if (position.equalsIgnoreCase("suffix")) {
    int output_counter = 0;
    for (int input_counter = 0; input_counter < input.length - 1; input_counter++) {
     output[output_counter] = input[input_counter];
     output_counter++;
    }
    return output;
   }
   return input;
  }
 };

 // Method 5:	Duplicate byte
 // Parameters:
 // 	Position: Prefix - Middle - Suffix
 public static final functionTwoParameters m5_duplicateByte = new functionTwoParameters() {

  @Override
  public byte[] run(byte[] input, String position) {
   nameOfLastExecutedFunction = "m5_duplicateByte";
   byte[] output = Arrays.copyOf(input, input.length + 1);
   Random random = new Random();

   byte temp = 0;
   int randomPosition = 0;

   if (position.equalsIgnoreCase("prefix")) {
    for (int i = 0; i < input.length; i++) {
     output[i + 1] = output[i];
    }
    output[0] = output[1];
    return output;

   }
   if (position.equalsIgnoreCase("middle")) {
    randomPosition = random.nextInt(input.length);

    for (int i = randomPosition; i < input.length; i++) {
     output[i + 1] = output[i];
    }

    return output;

   }
   if (position.equalsIgnoreCase("suffix")) {

    output[input.length] = input[input.length - 1];
    return output;
   }
   return input;
  }
 };


 // Method 6: Replace byte
 // Parameters:
 // 	Position: Prefix - Middle (Random) - Suffix
 // 	Value: 	Random from 0 to 255
 public static final functionTwoParameters m6_replaceByte = new functionTwoParameters() {

  @Override
  public byte[] run(byte[] input, String position) {

   nameOfLastExecutedFunction = "m6_replaceByte";

   byte[] output = Arrays.copyOf(input, input.length);
   Random random = new Random();
   int randomPosition = random.nextInt(input.length);
   byte temp = 0;
   byte randomByte = (byte) random.nextInt(256);


   if (position.equalsIgnoreCase("prefix")) {
    output[0] = randomByte;

    return output;

   }
   if (position.equalsIgnoreCase("middle")) {
    int output_counter = 0;
    output[randomPosition] = randomByte;

    return output;
   }

   if (position.equalsIgnoreCase("suffix")) {
    output[input.length - 1] = randomByte;
    return output;
   }
   return input;
  }
 };

 // Method 7: Drop X most significant bits
 // Parmeters:
 //	X:	From 1 to 8 bits that make a byte
 public static final functionTwoParameters2 m7_dropLeftmostBits = new functionTwoParameters2() {

  @Override
  public byte[] run(byte[] input, int X) {

   nameOfLastExecutedFunction = "m7_dropLeftmostBits";

   byte[] output = Arrays.copyOf(input, input.length);
   char[] maskStr = "11111111".toCharArray();
   for (int i = 0; i < X; i++) {
    maskStr[i] = '0';
   }
   byte mask = (byte) Integer.parseInt(new String(maskStr), 2);
   for (int i = 0; i < output.length; i++) {
    output[i] = ((byte)(output[i] & mask));
   }
   return output;

  }
 };

 // Method 8: Drop X least significant bits 
 //	X: From 1 to 8 bits that make a byte
 public static final functionTwoParameters2 m8_dropRightmostBits = new functionTwoParameters2() {

  @Override
  public byte[] run(byte[] input, int X) {

   nameOfLastExecutedFunction = "m8_dropRightmostBits";

   byte[] output = Arrays.copyOf(input, input.length);
   char[] maskStr = "11111111".toCharArray();
   for (int i = 0; i < X; i++) {
    maskStr[maskStr.length - 1 - i] = '0';
   }

   byte mask = (byte) Integer.parseInt(new String(maskStr), 2);
   for (int i = 0; i < output.length; i++) {
    output[i] = ((byte)(output[i] & mask));
   }
   return output;
  }
 };

 // Method 9:	Flip sign bit of a byte
 // Parameters:
 // 	Position: 	Prefix - Middle - Suffix
 public static final functionTwoParameters m9_flipSign = new functionTwoParameters() {

  @Override
  public byte[] run(byte[] input, String position) {

   nameOfLastExecutedFunction = "m9_flipSign";

   byte[] output = Arrays.copyOf(input, input.length);
   Random random = new Random();
   // Sign is kept at 1st leftmost bit
   byte mask = (byte) 128; // 128 is 0b1000000 in binary == Xor will flip first bit

   if (position.equalsIgnoreCase("prefix")) {
    output[0] = (byte)(output[0] ^ mask);
   }
   if (position.equalsIgnoreCase("middle")) {
    int randomPosition = random.nextInt(output.length);
    output[randomPosition] = (byte)(output[randomPosition] ^ mask);
   }
   if (position.equalsIgnoreCase("suffix")) {
    output[output.length - 1] = (byte)(output[output.length - 1] ^ mask);
   }
   return output;
  }
 };

}