// Poor Data Injector
// 2015-2016 Seyma Nur Soydemir seyma@student.dei.uc.pt

package mutation;

import java.util.Random;

public class Operators_Double {

 // Variable that holds the name of the last executed mutation
 public static String nameOfLastExecutedFunction = null;

 // Pre-defined values
 static String characterSet = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
 static String numericSet = "0123456789";
 static String symbolSet = "!2@£#§$%&/{[]}'?~^";

 // Interfaces for the various mutations
 public interface functionOneParameter {
  double run(double input);
 }

 public interface functionTwoParameters {
  double run(double input, String direction);
 }

 public interface functionTwoParameters2 {
  double run(double input, String position);
 }


 // Method 1: Replace by random same-size decimal values
 public static final functionOneParameter m1_replaceBySameSizeDouble = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m1_replaceBySameSizeDouble";

   String inputStr = String.valueOf(input);
   int radixLoc = inputStr.indexOf('.');
   int size = inputStr.length();

   Random random = new Random();
   String temp = "";

   for (int i = 0; i < size; i++) {
    int rand = -1;
    if (i == 0) {
     rand = random.nextInt(numericSet.length() - 1) + 1;
    } else {
     rand = random.nextInt(numericSet.length());
    }

    temp = temp + numericSet.charAt(rand);
   }
   if (radixLoc >= 0) {
    temp = temp.substring(0, radixLoc) + '.' + temp.substring(radixLoc + 1);
   }
   double output = Double.parseDouble(temp);
   return output;
  }
 };


 // Method 2:	Add 1
 public static final functionOneParameter m2_add1 = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m2_add1";

   double output = input + 1;
   return output;

  }
 };


 // Method 3: Substract 1
 public static final functionOneParameter m3_substract1 = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m3_substract1";

   double output = input - 1;
   return output;
  }
 };


 // Method 4: Remove one random numeric character from data
 public static final functionOneParameter m4_removeOneNumeric = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m4_removeOneNumeric";

   double temp = 0;

   if (input < 0) {
    temp = input;
    input *= -1;
   }

   Random random = new Random();

   String inputStr = String.valueOf(input);


   // We can only remove if there is more than 1 digit
   if (inputStr.length() > 1) {
    int randomPosition = random.nextInt(inputStr.length());
    while (inputStr.charAt(randomPosition) == '.') {
     randomPosition = random.nextInt(inputStr.length());
    }
    inputStr = inputStr.substring(0, randomPosition) + inputStr.substring(randomPosition + 1);
    input = Double.parseDouble(inputStr);
   }

   if (temp < 0) {
    input *= -1;
   }
   return input;
  }
 };

 // Method 5: Duplicate one of the numeric characters
 public static final functionOneParameter m5_duplicateOneNumeric = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m5_duplicateOneNumeric";

   double temp = 0;
   if (input < 0) {
    temp = input;
    input *= -1;
   }
   Random random = new Random();
   String inputStr = String.valueOf(input);
   int randomPosition = random.nextInt(inputStr.length());
   while (inputStr.charAt(randomPosition) == '.') {
    randomPosition = random.nextInt(inputStr.length());
   }
   inputStr = inputStr.substring(0, randomPosition) + inputStr.charAt(randomPosition) + inputStr.substring(randomPosition);
   input = Double.parseDouble(inputStr);
   // input = BigDecimal.valueOf(inputStr);
   if (temp < 0) {
    input *= -1;
   }
   return input;
  }
 };

 // Method 6:	Reverse two consecutive characters
 public static final functionOneParameter m6_invertConsecutiveDigits = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m6_invertConsecutiveDigits";

   double temp = 0;

   if (input < 0) {
    temp = input;
    input *= -1;
   }

   Random random = new Random();
   char tempChar = 0;
   String inputStr = String.valueOf(input);

   if (inputStr.length() > 1) {
    int randomPosition = random.nextInt(inputStr.length() - 1);
    while (inputStr.charAt(randomPosition) == '.') {
     randomPosition = random.nextInt(inputStr.length() - 1);
    }
    char[] chars = inputStr.toCharArray();

    if (chars[randomPosition + 1] == '.') {
     chars[randomPosition + 1] = chars[randomPosition + 2];
    }
    tempChar = chars[randomPosition];
    chars[randomPosition] = chars[randomPosition + 1];
    chars[randomPosition + 1] = tempChar;

    inputStr = new String(chars);
    input = Double.parseDouble(inputStr);
   }
   if (temp < 0) {
    input *= -1;
   }
   return input;
  }
 };

 // Method 7:	Add numeric character
 public static final functionOneParameter m7_addOneRandomNumeric = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m7_addOneRandomNumeric";

   double temp = 0;

   if (input < 0) {
    temp = input;
    input *= -1;;
   }

   Random random = new Random();
   String inputStr = String.valueOf(input);
   int randomDigit = random.nextInt(10);

   int randomPosition = random.nextInt(inputStr.length());
   while (inputStr.charAt(randomPosition) == '.') {
    randomPosition = random.nextInt(inputStr.length());
   }

   inputStr = inputStr.substring(0, randomPosition) + String.valueOf(randomDigit) + inputStr.substring(randomPosition);

   input = Double.parseDouble(inputStr);

   if (temp < 0) {
    input *= -1;
   }

   return input;
  }
 };

 // Method 8:	Flip sign
 public static final functionOneParameter m8_flipSign = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m8_flipSign";

   input *= -1;

   return input;
  }
 };


 // Method 9:	Zero out  the integer part	 -	 -
 public static final functionOneParameter m9_zeroOutInteger = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m9_zeroOutInteger";

   double temp = 0;

   if (input < 0) {
    temp = input;
    input *= -1;
   }

   Random random = new Random();
   String inputStr = String.valueOf(input);
   int radixLoc = inputStr.indexOf('.');
   String integerStr = inputStr.substring(0, radixLoc);

   inputStr = inputStr.replaceAll(integerStr, "0");

   input = Double.parseDouble(inputStr);

   return input;
  }
 };

 // Method 10: Zero out the fractional part
 public static final functionOneParameter m10_zeroOutFractional = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m10_zeroOutFractional";

   double temp = 0;;
   if (input < 0) {
    temp = input;
    input *= -1;
   }

   Random random = new Random();
   String inputStr = String.valueOf(input);
   int radixLoc = inputStr.indexOf('.');
   String fractionalStr = inputStr.substring(radixLoc + 1);

   inputStr = inputStr.replaceAll(fractionalStr, "0");

   input = Double.parseDouble(inputStr);

   return input;
  }
 };


 // Method 11:	Remove the integer part	
 public static final functionOneParameter m11_removeIntegerPart = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m11_removeIntegerPart";

   double temp = 0;

   if (input < 0) {
    temp = input;
    input *= -1;
   }

   String inputStr = String.valueOf(input);
   int radixLoc = inputStr.indexOf('.');
   if (radixLoc < 0) {
    return 0;
   }
   String fractionalStr = inputStr.substring(radixLoc + 1);

   inputStr = fractionalStr;

   input = Double.parseDouble(inputStr);
   return input;
  }
 };


 // Method 12: Remove the fractional part
 public static final functionOneParameter m12_removeFractionalPart = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m12_removeFractionalPart";

   double temp = 0;

   if (input < 0) {
    temp = input;
    input *= -1;
   }

   String inputStr = String.valueOf(input);
   int radixLoc = inputStr.indexOf('.');
   if (radixLoc < 0) {
    return input;
   }

   String integerStr = inputStr.substring(0, radixLoc);
   inputStr = integerStr;

   input = Double.parseDouble(inputStr);
   return input;
  }
 };

 // Method 13: Remove the decimal separator
 public static final functionOneParameter m13_removeSeparator = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m13_removeSeparator";

   double temp = 0;

   if (input < 0) {
    temp = input;
    input *= -1;
   }

   String inputStr = String.valueOf(input);
   int radixLoc = inputStr.indexOf('.');
   if (radixLoc < 0) {
    return input;
   }
   String fractionalStr = inputStr.substring(radixLoc + 1);
   String integerStr = inputStr.substring(0, radixLoc);

   inputStr = integerStr + fractionalStr;

   input = Double.parseDouble(inputStr);
   return input;
  }
 };



 // Method 14:	Add 10^-X
 public static final functionOneParameter m14_add10x = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m14_add10x";

   double temp = 0;

   if (input < 0) {
    temp = input;
    input *= -1;
   }

   Random random = new Random();

   String inputStr = String.valueOf(input);
   int radixLoc = inputStr.indexOf('.');
   if (radixLoc < 0) {
    return 0;
   }
   String fractionalStr = inputStr.substring(radixLoc + 1);
   String integerStr = inputStr.substring(0, radixLoc);

   int randomXPosition = random.nextInt(fractionalStr.length()) + 1;
   double addX = Math.pow(10, randomXPosition);
   input += addX;

   return input;
  }
 };

 // Method 15:	Subtract 10^-X
 public static final functionOneParameter m15_substract10x = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m15_substract10x";

   double temp = 0;

   if (input < 0) {
    temp = input;
    input *= -1;
   }

   Random random = new Random();


   String inputStr = String.valueOf(input);
   int radixLoc = inputStr.indexOf('.');
   if (radixLoc < 0) {
    return 0;
   }
   String fractionalStr = inputStr.substring(radixLoc + 1);
   String integerStr = inputStr.substring(0, radixLoc);

   int randomXPosition = random.nextInt(fractionalStr.length()) + 1;
   double subX = Math.pow(10, randomXPosition);
   input -= subX;
   if (temp < 0) {
    input *= -1;
   }
   return input;
  }
 };

 // Method 16:	Shift decimal separator
 // Position:
 //  Direction:	left or right
 public static final functionTwoParameters m16_shiftDecimalSeparator = new functionTwoParameters() {

  @Override
  public double run(double input, String direction) {
   nameOfLastExecutedFunction = "m16_shiftDecimalSeparator";

   double temp = 0;

   if (input < 0) {
    temp = input;
    input *= -1;
   }

   String inputStr = String.valueOf(input);
   int radixLoc = inputStr.indexOf('.');
   if (radixLoc < 0) {
    return input;
   }

   char[] chars = inputStr.toCharArray();

   char tempChar = ' ';
   if (direction.equalsIgnoreCase("left")) {
    for (int i = 0; i < chars.length; i++) {
     if (chars[i] == '.') {
      tempChar = chars[i - 1];
      chars[i - 1] = chars[i];
      chars[i] = tempChar;
      break;
     }
    }
    inputStr = String.valueOf(chars);
    input = Double.parseDouble(inputStr);
   }

   if (direction.equalsIgnoreCase("right")) {
    for (int i = 0; i < chars.length - 1; i++) {
     if (chars[i] == '.') {
      tempChar = chars[i];
      chars[i] = chars[i + 1];
      chars[i + 1] = tempChar;
      break;
     }
    }
    inputStr = String.valueOf(chars);
    input = Double.parseDouble(inputStr);
   }
   if (temp < 0) {
    input *= -1;
   }
   return input;
  }
 };

 // Method 17: Add 1 zero next to  decimal separator	
 // Parameters:
 //  Position:	before - after
 public static final functionTwoParameters2 m17_addZero = new functionTwoParameters2() {

  @Override
  public double run(double input, String position) {
   nameOfLastExecutedFunction = "m17_addZero";

   Random random = new Random();
   double temp = 0;

   if (input < 0) {
    temp = input;
    input *= -1;
   }

   String inputStr = String.valueOf(input);
   int radixLoc = inputStr.indexOf('.');
   if (radixLoc < 0) {
    return input;
   }

   String fractionalStr = inputStr.substring(radixLoc + 1);
   String integerStr = inputStr.substring(0, radixLoc);

   if (position.equalsIgnoreCase("before")) {
    inputStr = integerStr + "0." + fractionalStr;
   }
   if (position.equalsIgnoreCase("after")) {
    inputStr = integerStr + ".0" + fractionalStr;

   }
   input = Double.parseDouble(inputStr);
   if (temp < 0) {
    input *= -1;
   }
   return input;
  }
 };

 // Method 18:	Swap fractional and integer parts
 public static final functionOneParameter m18_swapParts = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m18_swapParts";

   double temp = 0;

   if (input < 0) {
    temp = input;
    input *= -1;
   }

   //Random random = new Random();
   String inputStr = String.valueOf(input);
   int radixLoc = inputStr.indexOf('.');
   // if there is no .
   if (radixLoc == -1) {
    return input;
   }
   String fractionalStr = inputStr.substring(radixLoc + 1);
   String integerStr = inputStr.substring(0, radixLoc);

   inputStr = fractionalStr + '.' + integerStr;

   input = Double.parseDouble(inputStr);
   if (temp < 0) {
    input *= -1;
   }
   return input;

  }
 };


 // Method 19:	Reverse fractional part
 public static final functionOneParameter m19_reverseFractionalPart = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m19_reverseFractionalPart";

   double temp = 0;

   if (input < 0) {
    temp = input;
    input *= -1;
   }

   String inputStr = String.valueOf(input);
   int radixLoc = inputStr.indexOf('.');
   // if there is no .
   if (radixLoc == -1) {
    return input;
   }
   String fractionalStr = inputStr.substring(radixLoc + 1);
   String integerStr = inputStr.substring(0, radixLoc);
   String reverseFractionalStr = new StringBuffer(fractionalStr).reverse().toString();

   inputStr = integerStr + '.' + reverseFractionalStr;
   input = Double.parseDouble(inputStr);
   if (temp < 0) {
    input *= -1;
   }
   return input;
  }
 };

 // Method 20:	Reverse integer part
 public static final functionOneParameter m20_reverseIntegerPart = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m20_reverseIntegerPart";

   double temp = 0;

   if (input < 0) {
    temp = input;
    input *= -1;
   }

   String inputStr = String.valueOf(input);
   int radixLoc = inputStr.indexOf('.');
   // if there is no .
   if (radixLoc == -1) {
    return input;
   }
   String fractionalStr = inputStr.substring(radixLoc + 1);
   String integerStr = inputStr.substring(0, radixLoc);
   String reverseIntegerStr = new StringBuffer(integerStr).reverse().toString();

   inputStr = reverseIntegerStr + '.' + fractionalStr;
   input = Double.parseDouble(inputStr);
   if (temp < 0) {
    input *= -1;
   }
   return input;
  }
 };


 // Method 21:	Skipping decimal point near zero
 public static final functionOneParameter m21_skipPointNearZero = new functionOneParameter() {

  @Override
  public double run(double input) {
   nameOfLastExecutedFunction = "m21_skipPointNearZero";

   double temp = 0;
   if (input < 0) {
    temp = input;
    input *= -1;
   }
   String inputStr = String.valueOf(input);

   int radixLoc = inputStr.indexOf('.');
   String integerStr = inputStr.substring(0, radixLoc);
   String fractionalStr = inputStr.substring(radixLoc + 1);


   if (integerStr.equalsIgnoreCase("0")) {
    inputStr = fractionalStr;
   }
   if (fractionalStr.equalsIgnoreCase("0")) {
    inputStr = integerStr;
   }

   input = Integer.valueOf(integerStr);
   if (temp < 0) {
    input *= -1;
   }
   return input;
  }
 };

}