// Poor Data Injector
// 2015-2016 Seyma Nur Soydemir seyma@student.dei.uc.pt

package mutation;

import java.util.Random;

public class Operators_Integer {

 // Variable that holds the name of the last executed mutation
 public static String nameOfLastExecutedFunction = null;

 // Pre-defined variables
 static String characterSet = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
 static String numericSet = "0123456789";
 static String symbolSet = "!2@£#§$%&/{[]}'?~^";

 public interface functionOneParameter {
  long run(long input);
 }

 // Method1: Replace by random same-size integer values
 public static final functionOneParameter m1_replaceByRandomSamesize = new functionOneParameter() {

  @Override
  public long run(long input) {
   nameOfLastExecutedFunction = "m1_replaceByRandomSamesize";

   int size = String.valueOf(input).length();
   Random random = new Random();
   String temp = "";

   for (int i = 0; i < size; i++) {
    int rand = -1;
    if (i == 0) {
     rand = random.nextInt(numericSet.length() - 1) + 1;
    } else {
     rand = random.nextInt(numericSet.length());
    }

    temp = temp + numericSet.charAt(rand);

   }

   long result = Long.parseLong(temp);
   return result;
  }
 };


 // Method 2: Remove one numeric character from data
 public static final functionOneParameter m2_removeOneNumeric = new functionOneParameter() {

  @Override
  public long run(long input) {
   nameOfLastExecutedFunction = "m2_removeOneNumeric";

   long temp = 0;
   if (input < 0) {
    temp = input;
    input *= -1;
   }

   Random random = new Random();

   String inputStr = String.valueOf(input);

   // We can only remove if there is more than 1 digit
   if (inputStr.length() > 1) {
    int randomPosition = random.nextInt(inputStr.length());
    inputStr = inputStr.substring(0, randomPosition) + inputStr.substring(randomPosition + 1);
    input = Integer.valueOf(inputStr);
   } else {
    // We remove from 1 digit, it gets to 0
    return 0;
   }

   if (temp < 0) {
    input *= -1;
   }
   return input;

  }
 };

 // Method 3: Duplicate one of the numeric characters
 public static final functionOneParameter m3_duplicateOneNumeric = new functionOneParameter() {

  @Override
  public long run(long input) {
   nameOfLastExecutedFunction = "m3_duplicateOneNumeric";

   long temp = 0;
   if (input < 0) {
    temp = input;
    input *= -1;
   }

   Random random = new Random();
   String inputStr = String.valueOf(input);
   int randomPosition = random.nextInt(inputStr.length());
   inputStr = inputStr.substring(0, randomPosition) + inputStr.charAt(randomPosition) + inputStr.substring(randomPosition);
   input = Long.valueOf(inputStr);

   if (temp < 0) {
    input *= -1;
   }
   return input;
  }
 };

 // Method 4: Invert two consecutive digits
 public static final functionOneParameter m4_invertConsecutiveDigits = new functionOneParameter() {

  @Override
  public long run(long input) {
   nameOfLastExecutedFunction = "m4_invertConsecutiveDigits";

   long temp = 0;
   if (input < 0) {
    temp = input;
    input *= -1;
   }
   Random random = new Random();
   char tempChar = 0;
   String inputStr = String.valueOf(input);
   if (inputStr.length() > 1) {
    int randomPosition = random.nextInt(inputStr.length() - 1);
    char[] chars = inputStr.toCharArray();

    tempChar = chars[randomPosition];
    chars[randomPosition] = chars[randomPosition + 1];
    chars[randomPosition + 1] = tempChar;

    inputStr = new String(chars);
    input = Long.valueOf(inputStr);
   }
   if (temp < 0) {
    input *= -1;
   }
   return input;
  }
 };

 // Method 5: Add one numeric character
 public static final functionOneParameter m5_addOneRandomNumeric = new functionOneParameter() {

  @Override
  public long run(long input) {
   nameOfLastExecutedFunction = "m5_addOneRandomNumeric";

   long temp = 0;
   if (input < 0) {
    temp = input;
    input *= -1;
   }

   Random random = new Random();
   String inputStr = String.valueOf(input);
   int randomDigit = random.nextInt(10);
   int randomPosition = -1;
   // If we are adding a 0, we cannot add before the value or it has no
   // effect
   if (randomDigit == 0) {
    randomPosition = random.nextInt(inputStr.length() - 1) + 1;
   } else {
    randomPosition = random.nextInt(inputStr.length());
   }

   inputStr = inputStr.substring(0, randomPosition) + String.valueOf(randomDigit) + inputStr.substring(randomPosition);

   input = Long.parseLong(inputStr);
   if (temp < 0) {
    input *= -1;
   }

   return input;
  }
 };

 // Method 6: Flip sign
 public static final functionOneParameter m6_flipSign = new functionOneParameter() {

  @Override
  public long run(long input) {
   nameOfLastExecutedFunction = "m6_flipSign";

   input *= -1;

   return input;
  }
 };

 // Method 7: Replace one random numeric character
 public static final functionOneParameter m7_replaceWithRandom = new functionOneParameter() {

  @Override
  public long run(long input) {
   nameOfLastExecutedFunction = "m7_replaceWithRandom";

   Random random = new Random();
   String inputStr = String.valueOf(input);
   int randomPosition = random.nextInt(inputStr.length());
   int randomDigit = random.nextInt(10);
   inputStr = inputStr.substring(0, randomPosition) + String.valueOf(randomDigit) + inputStr.substring(randomPosition + 1);
   input = Long.parseLong(inputStr);
   int sign = random.nextInt(2);

   if (sign == 0) {
    input *= -1;
   }

   return input;
  }
 };

 // Method 8: Add 1
 public static final functionOneParameter m8_add1 = new functionOneParameter() {

  @Override
  public long run(long input) {
   nameOfLastExecutedFunction = "m8_add1";

   return input + 1;
  }
 };

 // Method 9: Substract 1
 public static final functionOneParameter m9_subtract1 = new functionOneParameter() {

  @Override
  public long run(long input) {
   nameOfLastExecutedFunction = "m9_subtract1";

   return input - 1;
  }
 };

}