// Poor Data Injector
// 2015-2016 Seyma Nur Soydemir seyma@student.dei.uc.pt

package mutation;

import java.sql.Time;
import java.util.Random;

public class Operators_Time {

 // Variable that holds the name of the last executed mutation
 public static String nameOfLastExecutedFunction = null;

 // Interfaces for the various mutations
 public interface functionOneParamter {
  java.sql.Time run(java.sql.Time input);
 }

 public interface functionTwoParameters {
  java.sql.Time run(java.sql.Time input, String field);
 }

 public interface functionTwoParameters2 {
  java.sql.Time run(java.sql.Time input, String position);
 }

 // Method 1: Replace by null value
 public static final functionOneParamter m1_replaceByNull = new functionOneParamter() {

  @Override
  public Time run(Time input) {
   nameOfLastExecutedFunction = "m1_replaceByNull";

   return null;
  }
 };

 // Method 2: Replace by empty dummy time
 public static final functionOneParamter m2_replaceByEmptyDummyTime = new functionOneParamter() {

  @Override
  public Time run(Time input) {
   nameOfLastExecutedFunction = "m2_replaceByEmptyDummyTime";

   java.sql.Time output = new Time(0, 0, 0);
   return output;
  }
 };

 // Method 3: Replace by random time
 // Parameters:
 // 	Position: hour - minute - second
 public static final functionTwoParameters m3_replaceByRandomTime = new functionTwoParameters() {

  @Override
  public Time run(Time input, String field) {
   nameOfLastExecutedFunction = "m3_replaceByRandomTime";

   java.sql.Time output = (Time) input.clone();

   // Helper variables
   int hour = input.getHours();
   int minute = input.getMinutes();
   int second = input.getSeconds();
   Random random = new Random();

   if (field.equalsIgnoreCase("hour")) {
    int randomHour = random.nextInt(24);
    output.setHours(randomHour);
   }

   if (field.equalsIgnoreCase("minute")) {
    int randomMinute = random.nextInt(60);
    output.setMinutes(randomMinute);
   }

   if (field.equalsIgnoreCase("second")) {
    int randomSecond = random.nextInt(60);
    output.setSeconds(randomSecond);
   }
   return output;
  }
 };


 // Method 4: Reverse field
 // Parameters:
 // 	Field: hour - minute - second
 public static final functionTwoParameters m4_reverseField = new functionTwoParameters() {

  @Override
  public Time run(Time input, String field) {
   nameOfLastExecutedFunction = "m4_reverseField";

   java.sql.Time output = (Time) input.clone();

   int randomPosition = 0;
   char[] chars;
   char temp = 0;
   if (field.equalsIgnoreCase("hour")) {
    // convert to chars or substring

    // Change it to string and invert
    int hour = input.getHours();
    String hourStr = String.valueOf(hour);

    if (hourStr.length() < 2) {
     hourStr = "0" + hourStr;
    }

    chars = hourStr.toCharArray();

    temp = chars[0];
    chars[0] = chars[1];
    chars[1] = temp;

    hourStr = new String(chars);

    output.setHours(Integer.parseInt(hourStr));

    return output;
   }

   if (field.equalsIgnoreCase("minute")) {
    int minute = input.getMinutes();
    String minuteStr = String.valueOf(minute);
    if (minuteStr.length() < 2) {
     minuteStr = "0" + minuteStr;
    }

    chars = minuteStr.toCharArray();
    temp = 0;

    temp = chars[0];
    chars[0] = chars[1];
    chars[1] = temp;

    minuteStr = new String(chars);
    output.setMinutes(Integer.parseInt(minuteStr));

    return output;
   }

   if (field.equalsIgnoreCase("second")) {
    int second = input.getSeconds();
    String secondStr = String.valueOf(second);

    if (secondStr.length() < 2) {
     secondStr = "0" + secondStr;
    }
    chars = secondStr.toCharArray();

    temp = chars[0];
    chars[0] = chars[1];
    chars[1] = temp;

    secondStr = new String(chars);
    output.setSeconds(Integer.parseInt(secondStr));

    return output;
   }

   return input;
  }
 };

 // Method 5: Add one extra character to time
 // Parameters:
 // 	Position: before hour - after hour - before minute - after minute - before second - after second
 public static final functionTwoParameters2 m5_addOneExtra = new functionTwoParameters2() {

  @Override
  public Time run(Time input, String position) {
   nameOfLastExecutedFunction = "m5_addOneExtra";

   java.sql.Time output = (Time) input.clone();
   int hour = input.getHours();
   int minute = input.getMinutes();
   int second = input.getSeconds();
   String hourStr = String.valueOf(hour);
   String minuteStr = String.valueOf(minute);
   String secondStr = String.valueOf(second);
   Random random = new Random();
   int extra = 0;
   if (position.equalsIgnoreCase("before hour")) {
    extra = random.nextInt(10);
    hourStr = Integer.toString(extra) + hourStr;
    output.setHours(Integer.parseInt(hourStr));
   }

   if (position.equalsIgnoreCase("after hour")) {
    extra = random.nextInt(10);
    hourStr = hourStr + Integer.toString(extra);
    output.setHours(Integer.parseInt(hourStr));
   }

   if (position.equalsIgnoreCase("before minute")) {
    extra = random.nextInt(10);
    minuteStr = Integer.toString(extra) + minuteStr;
    output.setMinutes(Integer.parseInt(minuteStr));

   }

   if (position.equalsIgnoreCase("after minute")) {
    extra = random.nextInt(10);
    minuteStr = minuteStr + Integer.toString(extra);
    output.setMinutes(Integer.parseInt(minuteStr));

   }

   if (position.equalsIgnoreCase("before second")) {
    extra = random.nextInt(10);
    secondStr = Integer.toString(extra) + secondStr;
    output.setSeconds(Integer.parseInt(secondStr));
   }

   if (position.equalsIgnoreCase("after second")) {
    extra = random.nextInt(10);
    secondStr = secondStr + Integer.toString(extra);
    output.setSeconds(Integer.parseInt(secondStr));
   }

   return output;
  }
 };


 // Method 6: Duplicate one character on time value
 // Parameters:
 // 	Position: hour - minute - second
 public static final functionTwoParameters m6_duplicateOneDigit = new functionTwoParameters() {

  @Override
  public Time run(Time input, String field) {
   nameOfLastExecutedFunction = "m6_duplicateOneDigit";

   java.sql.Time output = (Time) input.clone();
   int hour = input.getHours();
   int minute = input.getMinutes();
   int second = input.getSeconds();
   String hourStr = String.valueOf(hour);
   String minuteStr = String.valueOf(minute);
   String secondStr = String.valueOf(second);
   Random random = new Random();
   int randomPosition = 0;
   int extra = 0;

   if (field.equalsIgnoreCase("hour")) {
    randomPosition = random.nextInt(hourStr.length());
    hourStr = hourStr.substring(0, randomPosition) + hourStr.charAt(randomPosition) + hourStr.substring(randomPosition);
    output.setHours(Integer.valueOf(hourStr));
    return output;
   }
   if (field.equalsIgnoreCase("minute")) {
    randomPosition = random.nextInt(minuteStr.length());
    minuteStr = minuteStr.substring(0, randomPosition) + minuteStr.charAt(randomPosition) + minuteStr.substring(randomPosition);
    output.setMinutes(Integer.valueOf(minuteStr));
    return output;
   }
   if (field.equalsIgnoreCase("second")) {
    randomPosition = random.nextInt(secondStr.length());
    secondStr = secondStr.substring(0, randomPosition) + secondStr.charAt(randomPosition) + secondStr.substring(randomPosition);

    output.setSeconds(Integer.valueOf(secondStr));
    return output;
   }


   return input;
  }
 };

 // Method 7: Remove one character of time value
 // Parameters:
 // 	Position: hour - minute - second
 public static final functionTwoParameters m7_removeOneDigit = new functionTwoParameters() {

  @Override
  public Time run(Time input, String field) {
   nameOfLastExecutedFunction = "m7_removeOneDigit";

   java.sql.Time output = (Time) input.clone();
   int hour = input.getHours();
   int minute = input.getMinutes();
   int second = input.getSeconds();
   String hourStr = String.valueOf(hour);
   String minuteStr = String.valueOf(minute);
   String secondStr = String.valueOf(second);
   Random random = new Random();
   int randomPosition = 0;
   int extra = 0;
   System.out.println(hourStr);
   if (field.equalsIgnoreCase("hour")) {
    randomPosition = random.nextInt(hourStr.length());
    System.out.println(randomPosition);
    if (randomPosition == 0) {
     hourStr = hourStr.substring(1);
    } else if (randomPosition == 1) {
     hourStr = hourStr.substring(0, 1);
    }
    // Verify if we removed all digits
    if (hourStr.equals("")) {
     hourStr = "0";
    }
    output.setHours(Integer.valueOf(hourStr));
    return output;
   }
   if (field.equalsIgnoreCase("minute")) {
    randomPosition = random.nextInt(minuteStr.length());
    if (randomPosition == 0) {
     minuteStr = minuteStr.substring(1);
    } else if (randomPosition == 1) {
     minuteStr = minuteStr.substring(0, 1);
    }
    // Verify if we removed all digits
    if (minuteStr.equals("")) {
     minuteStr = "0";
    }
    output.setMinutes(Integer.valueOf(minuteStr));
    return output;
   }
   if (field.equalsIgnoreCase("second")) {
    randomPosition = random.nextInt(secondStr.length());
    if (randomPosition == 0) {
     secondStr = secondStr.substring(1);
    } else if (randomPosition == 1) {
     secondStr = secondStr.substring(0, 1);
    }
    // Verify if we removed all digits
    if (secondStr.equals("")) {
     secondStr = "0";
    }
    output.setSeconds(Integer.valueOf(secondStr));
    return output;
   }


   return input;
  }
 };


}